<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset='utf-8'>
    <title>Lucky Dice Casino2</title>
    <meta name='viewport' content='width=device-width, initial-scale=1'>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.16.0/umd/popper.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <style>
        .picture-cover {
            background: url("LuckyDiceImages/cover.jpg");
            min-height: 100px;
            margin: 5px;
        }
    </style>
</head>
<script>
    "use strict";
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const vBASE_URL = "http://42.115.221.44:8080/devcamp-lucky-dice/";
    const vUTF8_TEXT_APPLICATION_HEADER = "application/json;charset=UTF-8";
    const gEND_OF_ROW_COL = -1;
    function onNewDiceClick() {
        var vUser = {
            username: "",
            firstname: "",
            lastname: "",
        };
        getData(vUser);
        if (validateData(vUser)) {
            var vXHTMLRequest = new XMLHttpRequest();
            callApiGetDice(vXHTMLRequest, vUser);
            vXHTMLRequest.onreadystatechange = function () {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                    console.log("responseText = " + vXHTMLRequest.responseText); //đây là responses text bạn có thể  phân tích 
                    var vResponse = JSON.parse(vXHTMLRequest.responseText);
                    console.log(vResponse);
                    processResponse(vResponse);
                    //   showDataOnTable(vXHTMLRequest); 
                    // code xử lý response ở đây
                    /*thêm code xử lý response*/
                }
            };
        }
    }
    function onDiceHistoryClick() {
        changeColorButton("dice-history");
        console.log("Nút Dice History được ấn");
        var vUser = {
            username: "",
            firstname: "",
            lastname: "",
        };
        getData(vUser);
        if (validateData(vUser)) {
            var vXHTMLRequest = new XMLHttpRequest();
            callApiGetDiceHistory(vXHTMLRequest, vUser);
            vXHTMLRequest.onreadystatechange = function () {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                    console.log("responseText = " + vXHTMLRequest.responseText); //đây là responses text bạn có thể  phân tích 
                    var vResponse = JSON.parse(vXHTMLRequest.responseText);
                    console.log(vResponse);
                    showDataOnTable(vXHTMLRequest);
                    // code xử lý response ở đây
                    /*thêm code xử lý response*/
                }
            };
        }
    }
    function changeColorButton(paramTypeButton) {
        var vBtnDiceHistory = $("#btn-dice-history");
        if (paramTypeButton == "dice-history") {
            vBtnDiceHistory.className = "btn btn-success button-width w-25";
        }
    }
    function deleteRowOnTables() {
        var table = $("#dice-history");

        while (table.rows.length > 0) {
            table.deleteRow(0);
        }
    }
    function showDataOnTable(paramRequest) {
        deleteRowOnTables();
        var vResponse = JSON.parse(paramRequest.responseText);
        var vTable = $("#dice-history");
        var vTableBody = vTable.getElementsByTagName("tbody")[0];
        var vHeader = vTable.insertRow(0);
        vHeader.insertCell(0).outerHTML = "<th>Lượt</th>";
        vHeader.insertCell(1).outerHTML = "<th>Dice</th>";
        for (var bIndex = 0; bIndex < vResponse.dices.length; bIndex++) {
            var vDice = vResponse.dices[bIndex];
            var vLuotValue = bIndex + 1;
            // tạo dòng mưới cho bẳng và ghi vào các giá trị 
            var vRow = vTableBody.insertRow(gEND_OF_ROW_COL);

            var vCellLuot = vRow.insertCell(gEND_OF_ROW_COL);
            var vCellDice = vRow.insertCell(gEND_OF_ROW_COL);
            vCellLuot.innerHTML = vLuotValue;
            vCellDice.innerHTML = vDice;
        }
    }
    function processResponse(paramResponse) {
        var vDice = paramResponse.dice;
        changeDice(vDice);
        changeNotificationDice(vDice);
        changeVoucher(paramResponse);
        changeGift(paramResponse);

    }
    function changeGift(paramResponse) {
        var vPresentImg = $("#img-present");
        switch (paramResponse.prize) {
            case "Mũ":
                vPresentImg.attr("src", "LuckyDiceImages/hat.jpg");
                break;
            case "Áo":
                vPresentImg.attr("src", "LuckyDiceImages/t-shirt.jpg");
                break;
            case "Xe máy":
                vPresentImg.attr("src", "LuckyDiceImages/xe-may.jpg");
                break;
            case "Ô tô":
                vPresentImg.attr("src", "LuckyDiceImages/car.jpg");
            default:
                vPresentImg.attr("src", "LuckyDiceImages/no-present.jpg");
                break;
        }
    }
    function changeVoucher(paramResponse) {
        var vVoucherIdElement = $("#p-voucher-id");
        var vVoucherPercentElement = $("#p-voucher-percent");
        if (paramResponse.voucher != null) {
            vVoucherIdElement.innerHTML = paramResponse.voucher.maVoucher;
            vVoucherPercentElement.innerHTML = paramResponse.voucher.phanTramGiamGia;
        }
    }
    function changeNotificationDice(paramDice) {
        var vResult = $("#result-dice");
        if (paramDice < 4) {
            vResult.innerHTML = "Chúc bạn may mắn lần sau";
        }
        else {
            vResult.innerHTML = "Xin chúc mừng";
        }
    }
    function changeDice(paramDice) {
        var vImgNewDiceElement = $("#img-new-dice");
        switch (paramDice) {
            case 1:
                vImgNewDiceElement.attr("src", "LuckyDiceImages/1.png");
                break;
            case 2:
                vImgNewDiceElement.attr("src", "LuckyDiceImages/2.png");
                break;
            case 3:
                vImgNewDiceElement.attr("src", "LuckyDiceImages/3.png");
                break;
            case 4:
                vImgNewDiceElement.attr("src", "LuckyDiceImages/4.png");
                break;
            case 5:
                vImgNewDiceElement.attr("src", "LuckyDiceImages/5.png");
                break;
            case 6:
                vImgNewDiceElement.attr("src", "LuckyDiceImages/6.png");
                break;
        }
    }
    function callApiGetDice(paramXmlHttp, paramUser) {
        'use strict';
        paramXmlHttp.open("POST", vBASE_URL + "/dice", true);
        paramXmlHttp.setRequestHeader("Content-Type", vUTF8_TEXT_APPLICATION_HEADER);
        paramXmlHttp.send(JSON.stringify(paramUser));  //chuyển Json object sang string
    }
    function callApiGetDiceHistory(paramXmlHttp, paramUser) {
        'use strict';
        var vUserName = paramUser.username;
        paramXmlHttp.open("GET", vBASE_URL + "/dice-history?username=" + vUserName, true);
        paramXmlHttp.setRequestHeader("Content-Type", vUTF8_TEXT_APPLICATION_HEADER);
        paramXmlHttp.send();  //chuyển Json object sang string
    }

    function validateData(paramUser) {
        if (paramUser.username == "") {
            alert("Bạn chưa nhập user name");
            return false;
        }
        if (paramUser.firstname == "") {
            alert("Bạn chưa nhập first name");
            return false;
        }
        if (paramUser.lastname == "") {
            alert("Bạn chưa nhập last name");
            return false;
        }
        return true;
    }
    function getData(paramUser) {
        var vUserNameElement = $("#inp-user-name");
        var vFirstNameElement = $("#inp-first-name");
        var vLastNameElement = $("#inp-last-name");
        paramUser.username = vUserNameElement.val().trim();
        paramUser.firstname = vFirstNameElement.val().trim();
        paramUser.lastname = vLastNameElement.val().trim();
    }
</script>

<body>
    <div class="container-fluid">
        <div class="picture-cover"></div>
    </div>
    <div class="container">
        <div class="row">
            <div class="col-sm-5">
                <div class="row form-group">
                    <div class="col-12">
                        <h4 class="text-left">
                            Nhập thông tin của bạn
                        </h4>
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-4">
                        <label> Username </label>
                    </div>
                    <div class="col-8">
                        <input type="text" id="inp-user-name" placeholder="Nhập username" class="form-control">
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-4">
                        <label> Firstname </label>
                    </div>
                    <div class="col-8">
                        <input type="text" id="inp-first-name" placeholder="Nhập firstname" class="form-control">
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-4">
                        <label> Lastname </label>
                    </div>
                    <div class="col-8">
                        <input type="text" id="inp-last-name" placeholder="Nhập lastname" class="form-control">
                    </div>
                </div>
            </div>
            <div class="col-sm-4">
                <div class="row form-group">
                    <div class="col-12 text-center">
                        <button type="button" onclick="onNewDiceClick()" id="btn-new-dice"
                            class="btn btn-success w-75">Ném</button>
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-12 text-center">
                        <img src="LuckyDiceImages/dice.png" id="img-new-dice" alt="" class="img-thumbnail">
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-12 text-center">
                        <p id="result-dice">Chúc mừng</p>
                    </div>
                </div>
            </div>
            <div class="col-sm-3">
                <div class="row form-group">
                    <div class="col-12 text-center">
                        <p>Voucher</p>
                        <p id="p-voucher-id">No Id</p>
                        <p id="p-voucher-percent">0%</p>
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-12">
                        <img id="img-present" src="LuckyDiceImages/xe-may.jpg" alt="" class="img-thumbnail">
                    </div>
                </div>
            </div>
        </div>
    </div>
</body>

</html>